/********************************************************************************************
**   Suchmaschine fuer private Homepages
**
**   Autor: Thomas Meyer   Mail: tom@all-community.de
**
**   nicht fr Firmen oder kommerzielle Nutzung, keine unerlaubte Weitergabe, kein Verkauf
**
**    2002, Thomas Meyer www.All-Community.de - Copyright Hinweis nicht entfernen!
**
*********************************************************************************************/

seiten = new Array();
stichworte = new Array();
ausgabe = new Array();
var trefferProSeite = 10;
var sucheNach = "";

/********************************************************************************************/

function ADD(url, titel, beschreibung) {

  var i = seiten.length;
  seiten[i] = new Object();
  seiten[i].TITEL    = titel;
  seiten[i].DESCR    = beschreibung;
  seiten[i].URL      = url;
  seiten[i].TARGET   = "_self";

};

function KEYWORDS(input) {

  input = input.substring(1, input.length -1);
  input = input.split(", ");

  for (var i = 0; i < input.length; i++) {
    var key = ((new String(input[i])).split('='))[0];
    var pages = (((new String(input[i])).split('='))[1]).split('"');
    if (key!="length") {
      if (!stichworte[key]) {
          stichworte[key]       = new Object();
          stichworte[key].DESCR = pages.shift();
          pages.pop();
      }
      stichworte[key].PAGE  = pages;
    };
  };

};

function SEITE(url, ziel, titel, beschreibung, schluesselworte) {
  var i = seiten.length;
  seiten[i] = new Object();
  seiten[i].TITEL    = titel;
  seiten[i].DESCR    = beschreibung;
  seiten[i].URL      = url;
  if (ziel == "") {
  seiten[i].TARGET   = "_self";
  } else {
  seiten[i].TARGET   = ziel;
  };

  keys = schluesselworte.split(',');
  for (var j = 0; j < keys.length; j++) {
    keys[j] = encodeString(keys[j]);
    if (!stichworte[keys[j]]) {
      stichworte[keys[j]]         = new Object();
      stichworte[keys[j]].DESCR   = "";
      stichworte[keys[j]].PAGE    = new Array();
      stichworte[keys[j]].PAGE[0] = i;
    } else {
      stichworte[keys[j]].DESCR   = "";
      stichworte[keys[j]].PAGE    = (stichworte[keys[j]].PAGE).concat(i);
    }
  };
};

function suche(suchbegriff) {

  var treffer = new Array();

  sucheNach = "";

  var suche = suchbegriff.split(" ");

  for (var i = 0; i < suche.length; i++) {
    sucheNach += "<br>" + suche[i] + " ";
    suche[i] = encodeString(suche[i]);
    if (suche[i] != "" && stichworte[suche[i]]) {
      if (stichworte[suche[i]].DESCR != "") { sucheNach += '<a href="javascript:whatsRelated()" target="suchmaske"><small><span style="font-weight: normal">[' + stichworte[suche[i]].DESCR + "]</span></small></a>"; };
      treffer[treffer.length] = stichworte[suche[i]].PAGE;
    };
  };
  ausgabe = new Array();

  if (treffer[0] != null && treffer[0] != "") {
      ausgabe = treffer[0];

      // 'UND' - Verknpfung
      for (var i = 1; i < treffer.length; i++) {
        for (var j = 0; j < ausgabe.length; j++) {
          if (ausgabe[j] != null && ! arrayContains(treffer[i], ausgabe[j])) {
            ausgabe = arrayRemove(ausgabe, j);
            j--;
          };
        };
      };
  } else { sucheNach = suchbegriff; };

  out(0);

};

function out(beginn) {

  var neueSeite = null;

  neueSeite = window.open('', 'suche');

  neueSeite.document.clear();

  neueSeite.document.writeln(head);
  neueSeite.document.writeln('<hr>');
  neueSeite.document.writeln('<table align="center" border="0"><tr><td align="left" vAlign="top">');
  neueSeite.document.writeln('<P CLASS="KOMMENTAR">gesucht wurde nach: <b>'+sucheNach+'</b></P>');
  neueSeite.document.writeln(suchErgebnis(beginn));
  neueSeite.document.writeln(foot);

  neueSeite.document.close();

};

function arrayRemove(inputArray, element) {

  var ziel = inputArray[element];
  if (ziel != "") {

    var alles = "," + inputArray.join(",") + ",";
    alles = alles.substring(0, alles.indexOf(","+ziel+",")) + alles.substring(alles.indexOf(","+ziel+",")+ ziel.length + 1, alles.length);
    alles = alles.substring(1, alles.length-1);

    inputArray = alles.split(",");

  } else {

    inputArray = new Array();

  };

  return inputArray;
};

function arrayContains(array, element) {

  for (var i = 0; i < array.length; i++) {
    if (array[i] == element) { return true };
  };

  return false;

};

function encodeString(inputString) {

  inputString = inputString.toLowerCase();

  inputString = inputString.replace(//gi, 'a');
  inputString = inputString.replace(/\&auml;/gi, 'a');
  inputString = inputString.replace(//gi, 'u');
  inputString = inputString.replace(/\&uuml;/gi, 'u');
  inputString = inputString.replace(//gi, 'o');
  inputString = inputString.replace(/\&ouml;/gi, 'o');
  inputString = inputString.replace(//gi, 'ss');
  inputString = inputString.replace(/\&szlig;/gi, 'ss');
  inputString = inputString.replace(/\&nbsp;/gi, ' ');
  inputString = inputString.replace(/[^\w_\s]/gi, "");

  if (inputString=="und" || inputString=="oder" || inputString=="aber" || inputString=="et" || inputString=="cetera" ||inputString=="etc" || inputString=="usw" || inputString=="bzw" || inputString=="beziehungsw" || inputString=="beziehungsweise" || inputString=="weiterer" || inputString=="weiter" || inputString=="weitere" || inputString=="weiteren" || inputString=="wer" || inputString=="wie" || inputString=="was" || inputString=="zum" || inputString=="sich" || inputString=="mit" || inputString=="und" || inputString=="dem" || inputString=="denen" || inputString=="deren" || inputString=="dessen" || inputString=="von" || inputString=="der" || inputString=="die" || inputString=="das" || inputString=="ich" || inputString=="sie" || inputString=="wir" || inputString=="ihr" || inputString=="ihnen" || inputString=="ihren" || inputString=="deinen" || inputString=="den" || inputString=="des" || inputString=="ihn" || inputString=="ihm") {
      inputString = "";
  } else {

      if (inputString.match(/^selbst/i) && inputString.length > 6) { inputString = inputString.substring(6, inputString.length);
      } else if (inputString.match(/^gross/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^durch/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^gegen/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^haupt/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^neben/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^unter/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^nacht/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^klein/i) && inputString.length > 5) { inputString = inputString.substring(5, inputString.length);
      } else if (inputString.match(/^voll/i) && inputString.length > 4) { inputString = inputString.substring(4, inputString.length);
      } else if (inputString.match(/^fern/i) && inputString.length > 4) { inputString = inputString.substring(4, inputString.length);
      } else if (inputString.match(/^ober/i) && inputString.length > 4) { inputString = inputString.substring(4, inputString.length);
      } else if (inputString.match(/^nach/i) && inputString.length > 4) { inputString = inputString.substring(4, inputString.length);
      } else if (inputString.match(/^uber/i) && inputString.length > 4) { inputString = inputString.substring(4, inputString.length); };
    
    
      if (inputString.match(/lichkeiten$/gi)) { inputString = inputString.substring(0, inputString.length-10);
      } else if (inputString.match(/igkeiten$/gi)) { inputString = inputString.substring(0, inputString.length-8);
      } else if (inputString.match(/igkeit$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/lichkeiten$/gi)) { inputString = inputString.substring(0, inputString.length-10);
      } else if (inputString.match(/lichkeit$/gi)) { inputString = inputString.substring(0, inputString.length-8);
      } else if (inputString.match(/lichen$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/lichem$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/ungen$/gi)) { inputString = inputString.substring(0, inputString.length-5);
      } else if (inputString.match(/ungem$/gi)) { inputString = inputString.substring(0, inputString.length-5);
      } else if (inputString.match(/iges$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/igen$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/igem$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/keiten$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/keit$/gi)) { inputString = inputString.substring(0, inputString.length-4);
      } else if (inputString.match(/lichen$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/lichem$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/lich$/gi)) { inputString = inputString.substring(0, inputString.length-4);
      } else if (inputString.match(/heiten$/gi)) { inputString = inputString.substring(0, inputString.length-6);
      } else if (inputString.match(/enden$/gi) && inputString != "enden") { inputString = inputString.substring(0, inputString.length-5);
      } else if (inputString.match(/end$/gi)) { inputString = inputString.substring(0, inputString.length-3);
      } else if (inputString.match(/ende$/gi) && inputString != "ende") { inputString = inputString.substring(0, inputString.length-4);
      } else if (inputString.match(/heit$/gi)) { inputString = inputString.substring(0, inputString.length-4);
      } else if (inputString.match(/ung$/gi)) { inputString = inputString.substring(0, inputString.length-3);
      } else if (inputString.match(/tum$/gi)) { inputString = inputString.substring(0, inputString.length-3);
      } else if (inputString.match(/ten$/gi)) { inputString = inputString.substring(0, inputString.length-3);
      } else if (inputString.match(/tem$/gi)) { inputString = inputString.substring(0, inputString.length-3);
      } else if (inputString.match(/em$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/en$/gi)) {inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/er$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/es$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/te$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/ts$/gi)) { inputString = inputString.substring(0, inputString.length-2);
      } else if (inputString.match(/t$/gi)) { inputString = inputString.substring(0, inputString.length-1);
      } else if (inputString.match(/e$/gi)) { inputString = inputString.substring(0, inputString.length-1);
      } else if (inputString.match(/s$/gi)) { inputString = inputString.substring(0, inputString.length-1); };

  };

  return inputString;

};

var head =
         '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"\n\n>' +
         '<html>\n\n' +
         '<head>\n' +
         '  <meta http-equiv="Content-Type" content="text/html; charset=windows-1252">\n' +
         '  <title>Suchseite</title>\n' +
         '  <link rel="stylesheet" type="text/css" href="suchmaschine.css">\n' +
         '  <style>.COPYRIGHT { color: black; font-size: 9pt; font-family: \'Arial\', \'Helvetica\'; font-weight: bold; text-decoration: none}</style>\n' +
         '</head>\n\n' +
         '<body>';

var foot =
         '<hr>\n' +
         '<P class="COPYRIGHT">powered by <A HREF="http://www.All-Community.de" TARGET="_blank">www.All-Community.de</A></P>\n' +
         '</body>\n\n' +
         '</html>';

function suchErgebnis(beginn) {

  var ende = (beginn+trefferProSeite >= ausgabe.length) ? ausgabe.length : beginn+trefferProSeite;

  var ergebnis = "";

  if (ausgabe.length > trefferProSeite) {
   ergebnis += '<TABLE WIDTH="100%"><TR><TD WIDTH="20%" ALIGN="RIGHT" CLASS="KOMMENTAR">\n';
   if (beginn > 0) {
      ergebnis += '<A HREF="javascript:parent.suchmaske.out('+((beginn-trefferProSeite > 0) ? beginn-trefferProSeite : 0)+')">ZUR&Uuml;CK</A>';
   } else {
      ergebnis += '&nbsp;';
   };
   ergebnis += '</TD><TD ALIGN="CENTER" WIDTH="40%" CLASS="KOMMENTAR" nowrap><b>Ansicht:</b> '+ende+' von '+ausgabe.length+'\n</TD><TD WIDTH="20%" CLASS="KOMMENTAR">';
   if (ende != ausgabe.length) {
      ergebnis += '<A HREF="javascript:parent.suchmaske.out('+ende+')" ALIGN="LEFT">VOR</A>';
   } else {
      ergebnis += '&nbsp;';
   };
   ergebnis += '</TD></TR></TABLE>\n';
  };

    for (var i = beginn; i < ende; i++) {
        ergebnis += '<P><A CLASS="SUCHBEGRIFF" HREF="'+ seiten[ ausgabe[i] ].URL +'" TARGET="'+ seiten[ ausgabe[i] ].TARGET +'">'+ seiten[ ausgabe[i] ].TITEL +'</A><BR><SPAN CLASS="BESCHREIBUNG">'+ seiten[ ausgabe[i] ].DESCR +'</SPAN></P>\n';
    };

  ergebnis +='<P CLASS="KOMMENTAR">Ihre Suche ergab '+ ausgabe.length +' Treffer</P>\n' +
             '</td></tr></table>';

  return ergebnis;
};

var logo = '<H1>Suchmaschine</H1>\n' +
           '<hr>';

var suchmaske =
           '<form name="suchform" onSubmit="suche(document.suchform.suchbegriff.value); return false;">\n' +
           '<table align="center" border="0"><tr><td align="left" vAlign="top">\n' +
           '<P><b>Suche:</b>&nbsp;<input id="suchbegriff" name="suchbegriff" type="text">&nbsp;<input type="submit" value="und los !"><br>\n' +
           '&nbsp;&nbsp;<A HREF="javascript:about()"><FONT color="black" face="Arial, Helvetica" style="text-decoration: none; font-size: 9pt"><STRONG>Copyright &amp; Disclaimer</STRONG></FONT></A></P>\n' +
           '</td></tr></table>\n' +
           '</form>';

function whatsRelated() {

  var infoSeite = window.open("", "_blank", "width=350, height=500, scrollbars=yes");
  with (infoSeite.document) {
    writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">');
    writeln('\n<html>\n<head>\n  <title>Info</title>\n</head>\n\n<body link="orange" vlink="orange" alink="orange" bgColor="darkred" text="white">\n');
    writeln('<style>');
    writeln('  A:HOVER { color: antiquewhite }');
    writeln('  P       { FONT-SIZE: 10pt; MARGIN: 10pt }');
    writeln('  UL      { FONT-SIZE: 11pt; COLOR: orange; FONT-WEIGHT: bold }');
    writeln('</style>');
    writeln('  <font face="Arial, Helvetica">');
    writeln('<DIV align=justify>');
    writeln('<H3>Was ist das?</H3>');
    writeln('<H4>Verwandte Begriffe:</H4>');
    writeln('<P>Um ihnen die Suche zu erleichtern sucht dieses Programm automatisch auch nach mit den gesuchten W&ouml;rtern evtl. verwandten Begriffen.');
    writeln('<P>Das hei&szlig;t: angenommen sie suchen nach &quot;neu&quot; dann werden ihnen auch Seiten vorgeschlagen, die verwandte Begriffe wie &quot;Neuigkeiten&quot; oder &quot;Neues&quot; enthalten.');
    writeln('Also &quot;Neu|<i>igkeiten</i>&quot; bzw. &quot;Neu<i>|es</i>&quot;.');
    writeln('<P>Geben sie stattdessen ein &quot;Dach&quot; wird auch &quot;&Uuml;berdachung&quot; (&quot;<i>&Uuml;ber~</i>&nbsp;dach&nbsp;<i>|ung&quot;</i>) gefunden.');
    writeln('<BR>Gleichzeitig wird versucht Begriffe, die zwar &auml;hnlich klingen aber nicht zum Thema passen wie z.Bsp. &quot;Dach&uuml;berstand&quot; auszublenden.</P>');
    writeln('<P><strong>Wollen sie mehr erfahren? Dann klicken sie hier: <a href="javascript:about()" target="suchmaske">Online-Hilfe</a></strong>');
    writeln('<HR><P>&copy; 2002 Thomas Meyer (www.All-Community.de)</P>');
    writeln('</DIV>');
    writeln('  </font>')
    writeln('</body>\n</html>');
    close();
  };

  infoSeite.focus();

};

function about() {

  var infoSeite = window.open("", "_blank", "width=350, height=500, scrollbars=yes");
  with (infoSeite.document) {
    writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">');
    writeln('\n<html>\n<head>\n  <title>Info</title>\n</head>\n\n<body link="orange" vlink="orange" alink="orange" bgColor="darkred" text="white">\n');
    writeln('<style>');
    writeln('  A:HOVER { color: antiquewhite }');
    writeln('  P       { FONT-SIZE: 10pt; MARGIN: 10pt }');
    writeln('  UL      { FONT-SIZE: 11pt; COLOR: orange; FONT-WEIGHT: bold }');
    writeln('</style>');
    writeln('  <font face="Arial, Helvetica">');
    writeln('<DIV align=justify>');
    writeln('<H3>Suchmaschine<BR>f&uuml;r private Homepages</H3>');
    writeln('<H4>Wie geht das?</H4>');
    writeln('<P>Um einen oder mehrere Begriffe zu suchen, geben sie die gew&uuml;nschten W&ouml;rter getrennt durch Leerzeichen ein.');
    writeln('Gro&szlig;- und Kleinschreibung m&uuml;ssen nicht beachtet werden.<BR>');
    writeln('Klicken sie auf "und los". Danach wird eine Liste der gefundenen Seiten angezeigt, die alle von ihnen angegebenen Suchbegriffe enthalten.');
    writeln('<P>Angezeigt werden der Name und eine kurze Beschreibung der gefundenen Seite(n). Wenn sie eine dieser Seiten anklicken, werden sie direkt weitergeleitet.');
    writeln('<H4>Autor</H4>');
    writeln('<P>Die Nutzung dieses Skriptes durch Firmen oder zu kommerziellen Zwecken ist nicht erlaubt. Weitergabe oder Verkauf ohne schriftliche Genehmigung sind untersagt.');
    writeln('Was kostenlos ist soll schlie&szlig;lich auch kostenlos bleiben ;)');
    writeln('<P>Einen eigene Suchmaschine f&uuml;r deine Homepage bekommst du bei uns.</P>');
    writeln('<P><strong>Autor:</strong> Thomas Meyer');
    writeln('<BR> <strong>Home:</strong> <a href="http://www.all-community.de" target="_blank">www.All-Community.de</a>');
    writeln('<BR> <strong>Mail:</strong> <a href="mailto:support@all-community.de" target="_blank">support@All-Community.de</a></p>');
    writeln('<P>Alle Rechte an diesem Tool liegen beim Autor.</p>');
    writeln('<H4>Haftungsausschluss</H4>');
    writeln('<P>Mit Urteil vom 12. Mai 1998 - 312 O 85/98 - hat das Landgericht (LG) in Hamburg entschieden, dass man durch die Anbringung eines Links, die Inhalte der gelinkten Seite ggf. mit zu verantworten hat. Dies kann - so das LG - nur dadurch verhindert werden, indem man sich ausdrcklich von diesen Inhalten distanziert. Hiermit distanzieren wir uns ausdrcklich von allen Inhalten aller verlinkten Seiten.</P>');
    writeln('<HR><P>&copy; 2002 Thomas Meyer (www.All-Community.de)</P>');
    writeln('</DIV>');
    writeln('  </font>')
    writeln('</body>\n</html>');
    close();
  };

  infoSeite.focus();

};

//  2002, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
